# 创建外星人Alien类
import pygame
from pygame.sprite import Sprite


class Alien(Sprite):
    """
        表示单个外星人的类
    """
    def __init__(self, ai_sttings, screen):
        super(Alien, self).__init__()
        self.screen = screen
        self.ai_settings = ai_sttings

        # 加载外星人的图片并设置其rect属性
        self.image = pygame.image.load('images/alien.bmp')
        self.rect = self.image.get_rect()

        # 设置外星人之间的间隔
        self.rect.x = self.rect.width    # 将外星人左边距设置为外星人的宽度
        self.rect.y = self.rect.height    # 将上边距设置为外星人的高度

        # 存储外星人的准确位置
        self.x = float(self.rect.x)

    def check_edges(self):
        """
            如果外星人位于屏幕边缘就返回True
        """
        screen_rect = self.screen.get_rect()
        if self.rect.right >= screen_rect.right:  # 外星人元素右边将要越过屏幕右边时的状态---此时处于触及屏幕右边缘
            return True
        elif self.rect.left <= 0:     # 外星人元素左边<= 0时代表将要越过屏幕左边---此时处于触及屏幕的左边缘
            return True

    def update(self):
        """
            向左或向右移动外星人
        """
        self.x += (self.ai_settings.alien_speed_factor
                   * self.ai_settings.fleet_direction)  # 速度 * 移动方向
        self.rect.x = self.x

    def blitem(self):
        """
            在指定位置绘制外星人的位置
        """
        self.screen.blit(self.image, self.rect)